float val[] = new float[256];
float valPrev[] = new float[256];
float delx = 1;
float delxSq = delx*delx;
float delt = 10;
float diffusionRate = 1.0;
float r = diffusionRate*delt/delxSq;

float boundStart = 0;
float boundEnd = 1;
float t = 0;
void setup() {
  size(512,300);
  println(r);
  for(int i=0;i<val.length;++i) {
    val[i] = sin(PI*i/val.length);
    valPrev[i] = sin(PI*i/val.length);
  }
}

void draw() {
  background(255);
  //draw colors
  strokeWeight(2);
  for(int i=0;i<val.length;++i) {
    stroke(50,constrain(val[i],0,1)*200,20);
    line(i*2,100,i*2,height);
  }
  //draw curve
  strokeWeight(1.0);
  stroke(0);
  for(int i=0;i<val.length-1;++i) {
    line(i*2,val[i]*50,(i+1)*2,val[i]*50);
  }
  for(int i=0;i<5;++i) stepDufortFrankel();
}

//different boundary conditions

void stepPeriodic() {
  //periodic boundary conditions
  float valNext[] = new float[256];
  for(int i=0;i<val.length;++i) {
    int iPrev = (i-1+val.length)%val.length;
    int iNext = (i+1)%val.length;
    valNext[i] = val[i]+delt*diffusionRate*(val[iPrev]+val[iNext]-2*val[i])/delxSq;
  }
  
  val = valNext;
}

void stepEdge() {
  //periodic boundary conditions
  float valNext[] = new float[256];
  for(int i=0;i<val.length;++i) {
    float vPrev, vNext;
    if(i==0) vPrev = val[i];
    else vPrev = val[i-1];
    if(i==val.length-1) vNext = val[i];
    else vNext = val[i+1];
    valNext[i] = val[i]+delt*diffusionRate*(vPrev+vNext-2*val[i])/delxSq;
  }
  val = valNext;
}

void stepFixed() {
  //periodic boundary conditions
  float valNext[] = new float[256];
  for(int i=0;i<val.length;++i) {
    float vPrev, vNext;
    if(i==0) vPrev = boundStart;
    else vPrev = val[i-1];
    if(i==val.length-1) vNext = boundEnd;
    else vNext = val[i+1];
    valNext[i] = val[i]+delt*diffusionRate*(vPrev+vNext-2*val[i])/delxSq;
  }
  val = valNext;
  t+=delt;
}

void stepMixed() {
  //periodic boundary conditions
  float valNext[] = new float[256];
  for(int i=0;i<val.length;++i) {
    float vPrev, vNext;
    if(i==0) vPrev = boundStart;
    else vPrev = val[i-1];
    if(i==val.length-1) vNext = val[i];
    else vNext = val[i+1];
    valNext[i] = val[i]+delt*diffusionRate*(vPrev+vNext-2*val[i])/delxSq;
  }
  val = valNext;
  t+=delt;
}

void stepDufortFrankel() {
  float valNext[] = new float[256];
  for(int i=0;i<val.length;++i) {
    float vPrev, vNext;
    if(i==0) vPrev = val[i];
    else vPrev = val[i-1];
    if(i==val.length-1) vNext = val[i];
    else vNext = val[i+1];
    valNext[i] = (1-r)/(1+r)*(valPrev[i])+r/(1+r)*(vPrev+vNext);
  }
  valPrev = val;
  val = valNext;
  t+=delt;
}


