float val[][] = new float[256][256];
float valPrev[][] = new float[256][256];
float delx = 1;
float delxSq = delx*delx;
float delt = 10;
float diffusionRate = 1.0;
float r = diffusionRate*delt/delxSq;

float boundStart = 0;
float boundEnd = 1;
float t = 0;
int[] sources = new int[100];
int[] sinks = new int[100];
void setup() {
  size(512,300);
  println(r);
  for(int i=0;i<val.length;++i) {
    for(int j=0;j<val[0].length;++j) {
      //val[i][j] = sq(cos(PI*(i*i+j*j)/(2.0*sq(val.length))));
      val[i][j] = 0;
      valPrev[i][j] = val[i][j];
    }
  }
  for(int i=0;i<sources.length;++i) {
    sources[i] = (int) random(val.length*val[0].length);
    sinks[i] = (int) random(val.length*val[0].length);
  }
}

void draw() {
  background(255);
  //draw colors
  loadPixels();
  for(int i=0;i<val.length;++i) {
    for(int j=0;j<val[0].length;++j) {
      pixels[j*width+i] = color(50,constrain(val[i][j],0,1)*200,20);
    }
  }
  updatePixels();
  for(int i=0;i<5;++i) stepDufortFrankel();
}

//different boundary conditions

void stepPeriodic() {
  //periodic boundary conditions
  float valNext[][] = new float[256][256];
  for(int i=0;i<val.length;++i) {
    for(int j=0;j<val[0].length;++j) {
      int iPrev = (i-1+val.length)%val.length;
      int iNext = (i+1)%val.length;
      int jPrev = (j-1+val[0].length)%val[0].length;
      int jNext = (j+1)%val[0].length;
      valNext[i][j] = val[i][j]+delt*diffusionRate*(val[iPrev][j]+val[iNext][j]+val[i][jPrev]+val[i][jNext]-4*val[i][j])/delxSq;
    }
  }

  val = valNext;
}

void stepDufortFrankel() {
  float valNext[][] = new float[256][256];
  for(int i=0;i<val.length;++i) {
    for(int j=0;j<val[0].length;++j) {
      float vPrev, vNext, jNext, jPrev;
      if(i==0) vPrev = val[i][j];
      else vPrev = val[i-1][j];
      if(i==val.length-1) vNext = val[i][j];
      else vNext = val[i+1][j];
      if(j==0) jPrev = val[i][j];
      else jPrev = val[i][j-1];
      if(j==val[0].length-1) jNext = val[i][j];
      else jNext = val[i][j+1];
      valNext[i][j] = (1-2*r)/(1+2*r)*(valPrev[i][j])+r/(1+2*r)*(vPrev+vNext+jPrev+jNext);
    }
  }
  valPrev = val;
  val = valNext;
  for(int i=0;i<sources.length;++i) {
    val[sources[i]%val.length][sources[i]/val.length] = 1;
    val[sinks[i]%val.length][sinks[i]/val.length] = 0;
  }
}



